/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.CourseNotebooks;
import vip.xiaonuo.disk.mapper.CourseNotebooksMapper;
import vip.xiaonuo.disk.param.CourseNotebooksAddParam;
import vip.xiaonuo.disk.param.CourseNotebooksEditParam;
import vip.xiaonuo.disk.param.CourseNotebooksIdParam;
import vip.xiaonuo.disk.param.CourseNotebooksPageParam;
import vip.xiaonuo.disk.service.CourseNotebooksService;

import java.util.List;

/**
 * 课程笔记本表Service接口实现类
 *
 * @author 金吉龙
 * @date  2025/07/01 18:40
 **/
@Service
public class CourseNotebooksServiceImpl extends ServiceImpl<CourseNotebooksMapper, CourseNotebooks> implements CourseNotebooksService {


    @Override
    public Page<CourseNotebooks> page(CourseNotebooksPageParam courseNotebooksPageParam) {
        QueryWrapper<CourseNotebooks> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(courseNotebooksPageParam.getSortField(), courseNotebooksPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(courseNotebooksPageParam.getSortOrder());
            queryWrapper.orderBy(true, courseNotebooksPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(courseNotebooksPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(CourseNotebooks::getNotebookId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(CourseNotebooksAddParam courseNotebooksAddParam) {
        CourseNotebooks courseNotebooks = BeanUtil.toBean(courseNotebooksAddParam, CourseNotebooks.class);
        this.save(courseNotebooks);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(CourseNotebooksEditParam courseNotebooksEditParam) {
        CourseNotebooks courseNotebooks = this.queryEntity(courseNotebooksEditParam.getNotebookId());
        BeanUtil.copyProperties(courseNotebooksEditParam, courseNotebooks);
        this.updateById(courseNotebooks);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<CourseNotebooksIdParam> courseNotebooksIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(courseNotebooksIdParamList, CourseNotebooksIdParam::getNotebookId));
    }

    @Override
    public CourseNotebooks detail(CourseNotebooksIdParam courseNotebooksIdParam) {
        return this.queryEntity(courseNotebooksIdParam.getNotebookId());
    }

    @Override
    public CourseNotebooks queryEntity(String id) {
        CourseNotebooks courseNotebooks = this.getById(id);
        if(ObjectUtil.isEmpty(courseNotebooks)) {
            throw new CommonException("课程笔记本表不存在，id值为：{}", id);
        }
        return courseNotebooks;
    }

}
